;**   PIC16F84  15081   25 *******
;
;   
; 00:   
; 01: -
; 02: .  1  03: .  1  
; 04: .  2  05: .  2
; ........
; 3E: .  31 3F: .  31
;  (* -  )
MEM01     EQU  0CH;*   
BITREV    EQU  00H;*     
BITMEM    EQU  01H;*    
BITUP     EQU  02H;*   UP
BITDWN    EQU  03H;*   DWN

MEM02     EQU  0DH;*  . .   .
MEM03     EQU  0EH;*  . . .
MEM04     EQU  0FH;     .
MEM05     EQU  10H;*    

MEM06     EQU  11H;*   
BITNASTR  EQU  00H;*   
BITKN     EQU  01H;*    
BITWR     EQU  02H;*     
BITNWCAN  EQU  03H;*   
BITNWKD   EQU  04H;*   
BITSMRV   EQU  05H;*   

MEM07     EQU  12H;*   . .
MEM08     EQU  13H;*  .  . 
MEM09     EQU  14H;*  .  . 
MEM10     EQU  15H;   
MEM11     EQU  16H;*  . .  .
MEM12     EQU  17H;*  /
MEM13     EQU  18H;   
MEM14     EQU  19H;*    .
MEM15     EQU  1AH;    
MEM16     EQU  1BH;   /
MEM17     EQU  1CH;   /
MEM18     EQU  1DH;   /
MEM19     EQU  1EH;   /
MEM20     EQU  1FH;   /
MEM21     EQU  20H;   /
MEM22     EQU  21H;   /
; MEM20-MEM21-MEM22 ()
MEM23     EQU  22H;   .  . .
MEM24     EQU  23H;*    
MEM25     EQU  24H;*  .   
MEM26     EQU  25H;*  .   
MEM27     EQU  26H;*  ..    SLEEP
MEM28     EQU  27H;*  ..    SLEEP
;
INDF      EQU  00H
STATUS    EQU  03H
C         EQU  00H;    STATUS,C
Z         EQU  02H;    STATUS,Z
RP0       EQU  05H;    STATUS,RP0
FSR       EQU  04H
PA        EQU  05H;    PORT A
;   A
CSIN      EQU  00H;    Clock Sint
DSIN      EQU  01H;    Data Sint
TSIN      EQU  02H;    Tact Sint

PB        EQU  06H;    PORT B
;   B
SERV      EQU  00H;     SERV
SKIND     EQU  01H;    SK 
DIIND     EQU  02H;    DI 
VALXD     EQU  03H;    DATA .
VALXC     EQU  04H;    CLOCK .
MEMR      EQU  05H;     MEMORY
UP        EQU  06H;     UP
DWN       EQU  07H;     DOWN

INTCON    EQU  0BH
RBIF      EQU  00H;    INTCON,RBIF
INTF      EQU  01H;    INTCON,INTF
GIE       EQU  07H;    INTCON,GIE
EEDATA    EQU  08H
EEADR     EQU  09H
TRISA     EQU  85H
TRISB     EQU  86H
EECON1    EQU  88H
RD        EQU  00H;    EECON1,RD
WR        EQU  01H;    EECON1,WR
WREN      EQU  02H;    EECON1,WREN
EEIF      EQU  04H;    EECON1,EEIF
EECON2    EQU  89H
OPT       EQU  81H;    OPTION

; 
CONDRV    EQU  20H; -  .  . 
CONDRKN   EQU  60H; -    . 
IMPCAN    EQU  06H; . .    
KDMINST   EQU  0BH; .  min  (65000+10700/25=3028)
KDMINML   EQU 0D4H; .  min 
KDMAXST   EQU  12H; .  max  (109000+10700/10=11970)
KDMAXML   EQU 0B4H; .  max 
KKV       EQU  02H; .  (10000/25=400)
DF        EQU  19H;   (25)
STFP      EQU  29H; .. F=10700
MLFP      EQU 0CCH; .. F
SLP       EQU  18H; ..    SLEEP

          LIST P=16F84

          ORG     0000H
          GOTO   INIT

;****** / . .  B ************
          ORG     0004H

; : MEM03 - . . .
;       MEM07 -  . .
; : MEM03 - . . .
;        MEM07 - . .
;        MEM01 -  
; : MEM02 - . .  .
;               MEM14 - 
;               MEM11, MEM12 - . .

PRER:     MOVWF  MEM11     ; . W
          SWAPF  STATUS,W
          MOVWF  MEM12     ; . STATUS
          BCF    STATUS,RP0; 0 .
          CALL   RDKN      ;  .  .
          MOVF   MEM02,W
          ANDLW  0E1H      ; 1110.0001  .
          BTFSC  STATUS,Z  ;  0,  
          GOTO   RDVLK     ;  .
          BTFSC  MEM02,SERV; SERV  
          BSF    MEM01,BITREV;    
          BTFSC  MEM02,MEMR; MEMR  
          BSF    MEM01,BITMEM;   
          BTFSC  MEM02,UP  ; UP  
          BSF    MEM01,BITUP;  UP
          BTFSC  MEM02,DWN ; DWN  
          BSF    MEM01,BITDWN;  DWN
          GOTO   PREREND   ;   
RDVLK:    BTFSS  MEM02,VALXC; CLOCK=1
          GOTO   RDV01     ; CLOCK=0
          BTFSC  MEM03,VALXC;  CLOCK=0
          GOTO   RDV02     ; CLOCK  ., =1
          BTFSS  MEM02,VALXD; XD=1
          GOTO   RDV03     ; XD=0, 
          GOTO   RDV04     ; XD=1, 
RDV01:    BTFSS  MEM03,VALXC;  CLOCK=1
          GOTO   RDV02     ; CLOCK  , =0
          BTFSC  MEM02,VALXD; XD=0
          GOTO   RDV03     ; XD=1, 
;
RDV04:    INCF   MEM07,F   ;  . .
          GOTO   RDV02
;
RDV03:    DECF   MEM07,F
RDV02:    MOVF   MEM02,W
          MOVWF  MEM03     ;  . .
PREREND:  MOVLW  SLP   ;  .   SLEEP
          MOVWF  MEM27 ; .. .   SLEEP
          CLRF   MEM28 ; .. .   SLEEP
          BCF    INTCON,RBIF;   . RB4-7
          BCF    INTCON,INTF;   . RB0
          SWAPF  MEM12,W
          MOVWF  STATUS     ; . STATUS
          SWAPF  MEM11,F
          SWAPF  MEM11,W ; . W   STATUS
          RETFIE

;******** /  .   . *********

; : MEM02 - . .   .
; : MEM14

RDKN:     MOVLW  CONDRV  ; -  
          MOVWF  MEM14   ; 
          COMF   PB,W
          ANDLW  0F9H    ; 1111.1001 
          MOVWF  MEM02   ; . . 
          ANDLW  0E1H    ; . 
          BTFSC  STATUS,Z;  0,  
          GOTO   RDK01   ; .  
          MOVLW  CONDRKN ; -  
          MOVWF  MEM14   ;
RDK01:    COMF   PB,W
          ANDLW  0F9H
          XORWF  MEM02,W ;   ., W=0
          BTFSS  STATUS,Z; 0,  
          GOTO   RDKN    ; ,  
          DECFSZ MEM14,F ; 
          GOTO   RDK01   ;  ,  
          RETURN

;*********** /   200  *************

; : MEM10, MEM13

ZAD200:   MOVLW  0FFH
          MOVWF  MEM10
ZAD3:     MOVLW  0FFH
          MOVWF  MEM13
ZAD2:     DECFSZ MEM13,F
          GOTO   ZAD2
          DECFSZ MEM10,F
          GOTO   ZAD3
          RETURN

;******* /  2-.   1.() *******

; :  MEM08, MEM09 -  ()
;        .   .
; : MEM17, MEM18, MEM19
;        .   .
; : MEM04, MEM15, MEM16

MUL168:   MOVF   MEM08,W
          MOVWF  MEM15    ; . . 
          MOVF   MEM09,W
          MOVWF  MEM16    ; . . 
          CLRF   MEM17    ; . . 
          CLRF   MEM18
          CLRF   MEM19    ; . . 
          MOVLW  10H
          MOVWF  MEM04    ; 
          MOVLW  DF       ; 10, 
          BCF    STATUS,C ; C=0
MUL01:    RRF    MEM15,F
          RRF    MEM16,F
          BTFSC  STATUS,C
          ADDWF  MEM17,F
          RRF    MEM17,F
          RRF    MEM18,F
          RRF    MEM19,F
          DECFSZ MEM04,F
          GOTO   MUL01
          RETURN

;********** /  F=10700 **************

; , : MEM17-MEM19
;              .. ..
; : MEM04

SUB32:    MOVLW  MLFP      ; .. 
          SUBWF  MEM19,F   ;  ..
          MOVLW  STFP      ; .. 
          MOVWF  MEM04     ; 
          BTFSS  STATUS,C
          INCFSZ MEM04,W   ; C=0,  
          SUBWF  MEM18,F   ; C=1,   
          CLRW
          MOVWF  MEM04
          BTFSS  STATUS,C
          INCFSZ MEM04,W
          SUBWF  MEM17,F
          RETURN

;******** /  3-.   10 *******

; : MEM17, MEM18, MEM19 - 
;       .          .
; : MEM17, MEM18, MEM19 - 
;                      MEM16 - 
; : MEM15

DL3B10: CLRF    MEM16;     .  
        MOVLW   18H;      - .
        MOVWF   MEM15;      
DEL3:   CALL    SDV3;      4-    
        RLF     MEM16,F
        MOVLW   0AH;      -->W
        SUBWF   MEM16,W;  MEM16-W-->W,  , =0
        BTFSC   STATUS,C;  =0,  ()
        MOVWF   MEM16;    
        DECFSZ  MEM15,F;   
        GOTO    DEL3;      24 
        CALL    SDV3;        . . 
        RETURN
SDV3:   RLF     MEM19,F
        RLF     MEM18,F
        RLF     MEM17,F
        RETURN

;/  3- .   2-.  2-10 

; : MEM17-MEM19
;       .  .
; :MEM20-MEM22
;       .  .
;    . 8- ,  MEM19=0
; : MEM15 - .  
;               MEM04 -  
;               MEM16 -   
;        MEM20 - MEM21 - MEM22

TRN3B10:BCF     STATUS,C; C=0
        MOVLW   03;       -  -
        MOVWF   MEM04;     
        MOVLW   MEM22;    . .  -
        MOVWF   FSR
TRN2:   CALL    DL3B10;     10
        MOVF    MEM16,W;  -->W
        MOVWF   INDF
        CALL    DL3B10
        SWAPF   MEM16,W;    MEM16-->W
        IORWF   INDF,F;   W  (FSR)-->(FSR) . .
        DECF    FSR,F;    FSR-1-->FSR
        DECFSZ  MEM04,F;   
        GOTO    TRN2
        RETURN

;**** /  N   2-10  ******

; : MEM05 - 
; : MEM18
; : MEM19

TRNCN:  CLRF   MEM18
        MOVF   MEM05,W
        MOVWF  MEM19     ; .  N
TR02:   MOVLW  0AH       ; 10
        SUBWF  MEM19,W   ; F-10-->W
        BTFSS  STATUS,C  ;   
        GOTO   TR01      ;  
        MOVWF  MEM19     ; 
        INCF   MEM18,F   ;  
        GOTO   TR02
TR01:   SWAPF  MEM18,F   ;   . 
        MOVF   MEM19,W   ; 
        ADDWF  MEM18,F   ; +  ()
        RETURN

;********* /    ********

;: MEM05 -  
;: MEM05=1,   30<MEM05<128
;       MEM05=1FH,   MEM05>128  0

CORCAN: MOVLW  01H        ; min  
        BTFSC  MEM05,07   ; .  =0
        MOVWF  MEM05      ; >128,  =1
        MOVF   MEM05,F
        BTFSC  STATUS,Z   ;  0
        MOVWF  MEM05      ; =0,  =1
        MOVLW  20H        ; max  +1
        SUBWF  MEM05,W    ; MEM05-W-->W
        MOVLW  1FH        ; max  
        BTFSC  STATUS,C   ;  <20H
        MOVWF  MEM05      ; >20H,  =31
        RETURN

;***** /  .   *********

; : MEM08, MEM09 - 
;       .   .
; : MEM15, MEM16

CORKD:  MOVLW  KDMAXST
        MOVWF  MEM15       ; . . max
        MOVLW  KDMAXML
        MOVWF  MEM16       ; . . max
        MOVF   MEM09,W     ; . . 
        SUBWF  MEM16,F     ;  max -  ..
        MOVF   MEM08,W     ; . . 
        BTFSS  STATUS,C    ;   
        INCFSZ MEM08,W     ; C=0,  
        SUBWF  MEM15,F     ;  max -  ..
        BTFSC  STATUS,C    ;  
        GOTO   CORK01      ;  ,  min
        MOVLW  KDMINST     ; KD=KDMIN
        MOVWF  MEM08
        MOVLW  KDMINML
        MOVWF  MEM09
        GOTO   CORKDEND
CORK01: MOVLW  KDMINST
        MOVWF  MEM15
        MOVLW  KDMINML
        MOVWF  MEM16
        MOVLW  01
        SUBWF  MEM16,F      ; .. - 1
        BTFSS  STATUS,C     ;   
        DECF   MEM15,F      ; , .. - 1
        MOVF   MEM09,W      ; .. 
        SUBWF  MEM16,F      ;  min -  ..
        MOVF   MEM08,W      ; .. 
        BTFSS  STATUS,C     ;   
        INCFSZ MEM08,W      ; C=0,  
        SUBWF  MEM15,F      ;  max -  ..
        BTFSS  STATUS,C     ;   
        GOTO   CORKDEND     ;  , 
        MOVLW  KDMAXST      ; KD=KDMAX
        MOVWF  MEM08
        MOVLW  KDMAXML
        MOVWF  MEM09
CORKDEND: RETURN

;*****************    ***************

;******* /    ********

; : W - , 0 .
; : W - 

RD01:   MOVWF  EEADR     ; 
        BSF    STATUS,RP0; 1- .
RD02:   BSF    EECON1,RD ; 
        BCF    STATUS,RP0; 0- .
        MOVF   EEDATA,W  ; 
        RETURN

;***** / . .  . (.=0) *****

; : 0 .
; : MEM05 - 

RDNC:   CLRW
        CALL   RD01
        MOVWF  MEM05
        RETURN

;******** /      ******

; : MEM05 -  
; : MEM04 - . .   

RSAD:   CALL   CORCAN     ;  > 1EH,  0
        BCF    STATUS,C   ; C=0
        MOVF   MEM05,W
        MOVWF  MEM04
        RLF    MEM04,F    ; x2 =   
        RETURN

;******** /     **********

; : 0 . MEM05 -  
; : MEM08 - .  
;        MEM09 - .  
; : MEM04

RDKD:   CALL    RSAD      ;  
        MOVF    MEM04,W   ; . . 
        CALL    RD01
        MOVWF   MEM08     ; .  
        INCF    MEM04,W   ; . . 
        CALL    RD01
        MOVWF   MEM09     ; .  
        RETURN

;***** / .-- .  *****

; : MEM10 - 
;       W - 
;       0 ., . 
; : MEM10 - . ,   .

;
RWR:    CALL    RD01      ; 
        SUBWF   MEM10,W
        BTFSC   STATUS,Z  ;   .
        RETURN            ; , 
;
        MOVF    MEM10,W
        MOVWF   EEDATA    ;   
        BSF     STATUS,RP0; 1 .
        BSF     EECON1,WREN; . 
        MOVLW   55H
        MOVWF   EECON2
        MOVLW   0AAH
        MOVWF   EECON2
        BSF     EECON1,WR ;  
WR01:   NOP
        BTFSS   EECON1,EEIF; =1,  .
        GOTO    WR01      ; . . .
        BCF     EECON1,WREN;  
        BCF     EECON1,EEIF;   . .
;
        CALL    RD02      ;   .  EEADR
        MOVWF   MEM10     ; . 
        RETURN

;******** /    . **********

; : MEM05 - 
; : MEM05 - . ,  

WRCAN:  MOVF    MEM05,W
        MOVWF   MEM10     ; 
        CLRW              ; W=0, 
        CALL    RWR       ; .-. .
        MOVF    MEM10,W
        MOVWF   MEM05     ; . .
        RETURN

;********* /   ****************

; , : MEM05 -  
;              MEM08 - . . 
;              MEM09 - . . 
; : MEM04, MEM10

WRKD:   CALL    RSAD      ;  . . .
        MOVF    MEM08,W
        MOVWF   MEM10     ; . . 
        MOVF    MEM04,W   ;  . .
        CALL    RWR       ;  . .
        MOVF    MEM10,W
        MOVWF   MEM08     ; . . .
        MOVF    MEM09,W
        MOVWF   MEM10     ; . . 
        INCF    MEM04,W   ;  . .
        CALL    RWR       ;  . . 
        MOVF    MEM10,W
        MOVWF   MEM09     ; . . . 
        RETURN

;*************   *************

INIT:   MOVLW  10H       ; 0001.0000
        MOVWF  PA        ; PA4 =1
        MOVLW  0F9H      ; 1111.1001
        MOVWF  PB        ; PB1, PB2 =0
        BSF    STATUS,RP0; 1 .
        MOVLW  0E0H      ; PA =OUT
        MOVWF  TRISA     ; 1110.0000
        MOVLW  0F9H      ; 1111.1001
        MOVWF  TRISB     ; PB1,PB2=OUT
        MOVLW  3FH       ; 0011.1111
        MOVWF  OPT       ; PB-., PB0 .1/0
        BCF    STATUS,RP0; 0 .
        MOVLW  18H       ; 0001.1000
        MOVWF  INTCON    ; RBIF, INTF =1
;  
        MOVLW  0CH       ; 1- 
        MOVWF  FSR
CLEAR:  CLRF   INDF
        INCF   FSR,F
        BTFSS  FSR,4
        GOTO   CLEAR
        BTFSS  FSR,5      ; =xx11.0000
        GOTO   CLEAR
        CALL   RDNC       ;  .  .
        CALL   CORCAN     ; 
        CALL   RDKD       ;  
        CALL   CORKD      ; 
        CALL   ZAGSINT    ;  .
        CALL   RDKN       ;  
        MOVF   MEM02,W
        MOVWF  MEM03      ;  . .
        MOVLW  SLP
        MOVWF  MEM27      ; .   SLEEP
        MOVLW  0AH        ; 10
        MOVWF  MEM04
CL01:   CALL   ZAD200     ; 200 ms 
        DECFSZ MEM04,F
        GOTO   CL01       ; 2 sek  . 

; 
OPROS:  BSF    INTCON,GIE ; . .
        MOVF   MEM08,W    ;     
        MOVWF  MEM25      ; /
        MOVF   MEM09,W    ; /
        MOVWF  MEM26      ; /
        MOVLW  01
        ANDWF  MEM06,F ;  ,  BITNASTR
        BTFSS  MEM01,BITREV; 1-  
        GOTO   OPR01      ; SERV  
        BCF    MEM01,BITREV
        MOVLW  01         ;  BITNASTR
        XORWF  MEM06,F    ;  BITNASTR
        BSF    MEM06,BITSMRV; -   
        GOTO   OPRKNEND
OPR01:  BTFSS  MEM01,BITMEM; 1-   
        GOTO   OPR02      ; MEMR  
        BCF    MEM01,BITMEM
        BCF    INTCON,GIE ;  .
        BSF    MEM06,BITWR;  . 
        BTFSS  MEM06,BITNASTR;  .
        GOTO   OPR03      ;  
        CALL   CORKD      ;   max, min 
        CALL   WRKD       ;  
        GOTO   OPR04
OPR03:  CALL   CORCAN     ;   max, min
        CALL   WRCAN      ;    .
OPR04:  BSF    INTCON,GIE ; . .
        GOTO   OPRKNEND
OPR02:  BTFSS  MEM01,BITUP; UP
        GOTO   OPR05      ; UP  
        BCF    MEM01,BITUP
        INCF   MEM05,F    ; +1
        GOTO   OPR06
OPR05:  BTFSS  MEM01,BITDWN; DWN
        GOTO   OPRVL      ;     
        BCF    MEM01,BITDWN
        DECF   MEM05,F    ; -1
OPR06:  CALL   CORCAN     ;   
OPRKNEND: BSF  MEM06,BITKN;   .
        GOTO   VVOD       ;  
; 
OPRVL:  BCF    INTCON,GIE ;  .
        BTFSS  MEM06,BITNASTR;  .
        GOTO   VLR        ;  
        BTFSS  MEM07,07   ; BIT7=1, 
        GOTO   PLUSKD     ; 
        COMF   MEM07,W    ; 
        ADDLW  01         ; +1
        SUBWF  MEM09,F    ;  W  . . 
        BTFSS  STATUS,C   ;   
        DECF   MEM08,F    ;  
        GOTO   OPRV01
PLUSKD: MOVF   MEM07,W
        ADDWF  MEM09,F    ;W+ .. 
        BTFSC  STATUS,C   ;   .
        INCF   MEM08,F    ;  .
OPRV01: CLRF   MEM07      ;   .
        BSF    INTCON,GIE
        CALL   CORKD
        GOTO   VVOD       ;  
VLR:    BTFSS  MEM07,07   ; BIT7=1, 
        GOTO   PLUSCAN    ; 
VLR01:  MOVLW  IMPCAN     ; - .   .
        ADDWF  MEM07,W    ;  + 
        BTFSC  STATUS,C   ;  .,   .
        GOTO   VLREND     ;    
        MOVWF  MEM07      ;   
        DECF   MEM05,F    ;  - 1
        GOTO   VLR01
PLUSCAN: MOVLW IMPCAN
        SUBWF  MEM07,W    ;  - 
        BTFSS  STATUS,C   ;  ,   .
        GOTO   VLREND     ;    
        MOVWF  MEM07      ;   
        INCF   MEM05,F    ;  + 1
        GOTO   PLUSCAN
VLREND: BSF    INTCON,GIE
        CALL   CORCAN
;  .  .
VVOD:   BTFSS  MEM06,BITSMRV;  
        GOTO   VV03       ;   .
        CALL   RDKD       ;  
        CALL   CORKD
VV03:   MOVF   MEM24,W    ;  
        XORWF  MEM05,W
        BTFSC  STATUS,Z   ;  
        GOTO   VV01       ; W=0, .  = .
        BTFSC  MEM06,BITNASTR;  
        GOTO   VV04  ; ., .  .  
        CALL   RDKD       ;  . 
        CALL   CORKD      ; 
VV04:   BSF    MEM06,BITNWCAN;   
VV01:   MOVF   MEM25,W    ; ..  
        XORWF  MEM08,W
        BTFSS  STATUS,Z
        BSF    MEM06,BITNWKD;   
        MOVF   MEM26,W
        XORWF  MEM09,W
        BTFSS  STATUS,Z
        BSF    MEM06,BITNWKD;   
        BTFSC  MEM06,BITNWKD;   
        CALL   ZAGSINT    ;  .
        MOVF   MEM06,W    ; 
        ANDLW  3CH        ; 0011.1100  
        BTFSC  STATUS,Z   ;  .  .
        GOTO   VVODEND    ;    .
        CALL   MUL168     ;  x 10
        CALL   SUB32      ;  F=10700
        CALL   TRN3B10    ;  F  2-10 
        CALL   TRNCN      ; 
        MOVLW  0FFH       ; . . . . (--)
        BTFSC  MEM06,BITNASTR;  
        MOVLW  0DDH       ; . . .
        BTFSC  MEM06,BITWR;  
        MOVLW  0EEH       ;   
        MOVWF  MEM19      ;  
        CALL   VIVIND     ;   .
VVODEND: BTFSS  MEM06,BITKN; .  
        GOTO   OTVAL      ;  
        CALL   ZAD200     ; 200 ms
        BTFSS  MEM06,BITWR;  
        GOTO   VV02       ;   
        MOVLW  0FFH       ; (--)
        BTFSC  MEM06,BITNASTR;  
        MOVLW  0DDH       ; . .  . .
        MOVWF  MEM19      ;  
        CALL   VIVIND     ;   .
VV02:   CLRF   MEM07      ;  . .
OTVAL:  MOVF   MEM05,W    ;     .
        MOVWF  MEM24
        DECFSZ MEM28,F
        GOTO   OPROS
        DECFSZ MEM27,F
        GOTO   OPROS
        CLRF   MEM07      ;  . .
        SLEEP
        GOTO   OPROS      ;  

;****** /   15081 ******

; : MEM08, MEM09 - 
;       .   .
; : MEM21-MEM23, MEM04
;   00000xxx.xxxxxxxx.xxxxxxxx
;      .     .     .
;     MEM21    MEM22    MEM23
; <---   .

;  
ZAGSINT:MOVLW  KKV        ;  
        MOVWF  MEM21
        MOVF   MEM08,W    ; .. 
        MOVWF  MEM22
        MOVF   MEM09,W    ; .. 
        MOVWF  MEM23
        BCF    STATUS,C   ; C=0
        CALL   SDVSIN     ;   5  
        CALL   SDVSIN
        CALL   SDVSIN
        CALL   SDVSIN
        CALL   SDVSIN
;  19 
        MOVLW  13H        ; - 
        MOVWF  MEM04      ; 
ZAGS01: CALL   SDVSIN     ; .  -->C
        BTFSC  STATUS,C   ; C=0
        BSF    PA,DSIN    ; C=1, DSIN=1
        BTFSS  STATUS,C   ; C=1
        BCF    PA,DSIN    ; C=0, DSIN=0
        BSF    PA,CSIN    ; CSIN=1
        NOP
        BCF    PA,CSIN    ; CSIN=0, . .
        DECFSZ MEM04,F    ;  
        GOTO   ZAGS01     ; . 
        NOP
        BSF    PA,TSIN
        NOP
        BCF    PA,TSIN    ; . 
        RETURN

; /  3-  
SDVSIN: RLF    MEM23,F
        RLF    MEM22,F
        RLF    MEM21,F
        RETURN

;******** /    **********

; : MEM18 - 
;       MEM19 - 
;       MEM20-MEM21-MEM22 - 
;  MEM04
; : MEM18-MEM22  

; 
VIVIND: MOVF   MEM18,W
        CALL   ZAMML  ;  00  0A  . .
        MOVWF  MEM18
        MOVF   MEM20,W
        CALL   ZAMML
        MOVWF  MEM20
        MOVF   MEM21,W
        CALL   ZAMENA ;   .  . .
        MOVWF  MEM21
        MOVF   MEM22,W
        CALL   ZAMENA
        MOVWF  MEM22
; 
        MOVLW  28H       ; 40 
        MOVWF  MEM04     ; 
        BCF    INTCON,GIE;  .
OUTIN:  CALL   SDV5      ; .  -->C
        BTFSC  STATUS,C  ; C=0
        BSF    PB,DIIND  ; DIIND=1
        BTFSS  STATUS,C  ; C=1
        BCF    PB,DIIND  ; DIIND=0
        BSF    PB,SKIND  ; SK=1
        GOTO   $+1
        BCF    PB,SKIND  ; SK=0, 
        DECFSZ MEM04,F   ; 
        GOTO   OUTIN
        CALL   SDV5      ; . MEM18-MEM22
        BCF    PB,DIIND  ; DI=0
        BSF    INTCON,GIE; . .
        RETURN

;/  00  0AH  W
ZAMENA: MOVWF  MEM04    ;  
        ANDLW  0F0H      ;  . 
        BTFSS  STATUS,Z  ; =0
        GOTO   ZAM01     ;  0
        MOVLW  0A0H      ;  00  A0H
        IORWF  MEM04,W
ZAMML:  MOVWF  MEM04     ;  . .
ZAM01:  MOVF   MEM04,W
        ANDLW  0FH       ;  . 
        BTFSS  STATUS,Z  ; =0
        GOTO   ZAM02     ;  0
        MOVLW  0AH       ;  00  0AH
        IORWF  MEM04,F
ZAM02:  MOVF   MEM04,W   ;  
        RETURN

;/  5  
SDV5:   RLF    MEM22,F
        RLF    MEM21,F
        RLF    MEM20,F
        RLF    MEM19,F
        RLF    MEM18,F
        RETURN

;**********   **************

; PIC16C84                    WDTE disable
        ORG    2007H;               |
;       DW     3FF9H; 11.1111.1111.1001
;                      .  .| XT
;                              PWRTE enable 
;       DW     3FE9H;  
;  PIC16F84
        DW     3FF1H; 11.1111.1111.0001
;       DW     0001H;  

        END
